Não pode escolher mais do que 25 tópicos Os tópicos devem começar com uma letra ou um número, podem incluir traços ('-') e podem ter até 35 caracteres.
 
 
 
 

347 linhas
16 KiB

  1. #!/bin/sh
  2. command -V gpg >/dev/null 2>&1 && GPG="gpg" || GPG="gpg2"
  3. [ -z ${PASSWORD_STORE_DIR+x} ] && PASSWORD_STORE_DIR="$HOME/.password-store"
  4. [ -r "$PASSWORD_STORE_DIR/.gpg-id" ] &&
  5. "$GPG" --list-secret-keys $(cat "$PASSWORD_STORE_DIR/.gpg-id") >/dev/null 2>&1 || {
  6. printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`%s --full-gen-key\` first.\\n" "$GPG"
  7. exit
  8. }
  9. ! command -v mbsync >/dev/null && printf "\`mbsync (isync package)\` must be installed to run mutt-wizard.\\n" && exit
  10. prefix="/usr/local"
  11. muttdir="${XDG_CONFIG_HOME:-$HOME/.config}/mutt" # Main mutt config location
  12. accdir="$muttdir/accounts" # Directory for account settings
  13. maildir="${XDG_DATA_HOME:-$HOME/.local/share}/mail" # Location of mail storage
  14. namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
  15. emailre=".+@.+\..+" # Regex to confirm valid email address
  16. muttshare="$prefix/share/mutt-wizard"
  17. mbsyncrc="${MBSYNCRC_HOME:-$HOME/.mbsyncrc}"
  18. mwconfig="$muttshare/mutt-wizard.muttrc"
  19. cachedir="${XDG_CACHE_HOME:-$HOME/.cache}/mutt-wizard"
  20. muttrc="$muttdir/muttrc"
  21. msmtprc="${XDG_CACHE_HOME:-$HOME/.config}/msmtp/config"
  22. ssltype="IMAPS" # This is later changed to `None` later in the script if using Protonmail
  23. for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" "/etc/ssl/cert.pem" "/usr/local/share/ca-certificates/"
  24. do
  25. [ -f "$x" ] && sslcert="$x" && break
  26. done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
  27. getaccounts() { accounts="$(find "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\..*//" | sort -n)" ;}
  28. list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
  29. getprofiles() { \
  30. unset msmtp_header msmtp_profile mutt_profile mbsync_profile
  31. printf "Creating profiles for \`%s\`..." "$title"
  32. msmtp_header="defaults
  33. auth on
  34. tls on
  35. tls_trust_file $sslcert
  36. logfile $XDG_CONFIG_HOME/msmtp/msmtp.log
  37. "
  38. msmtp_profile="account $title
  39. host $smtp
  40. port $sport
  41. from $fulladdr
  42. user $login
  43. passwordeval \"pass mutt-wizard-$title\"
  44. $starttlsoff
  45. "
  46. mbsync_profile="IMAPStore $title-remote
  47. Host $imap
  48. Port $iport
  49. User $login
  50. PassCmd \"pass mutt-wizard-$title\"
  51. AuthMechs LOGIN
  52. SSLType $ssltype
  53. CertificateFile $sslcert
  54. MaildirStore $title-local
  55. Subfolders Verbatim
  56. Path $XDG_DATA_HOME/mail/$title/
  57. Inbox $XDG_DATA_HOME/mail/$title/INBOX
  58. Flatten .
  59. Channel $title
  60. Expunge Both
  61. Master :$title-remote:
  62. Slave :$title-local:
  63. Patterns * !\"[Gmail]/All Mail\"
  64. Create Both
  65. SyncState *
  66. MaxMessages $maxmes
  67. ExpireUnread no
  68. # End profile
  69. "
  70. if [ "$accounttype" = "offline" ]; then
  71. mutt_profile="# vim: filetype=neomuttrc
  72. # muttrc file for account $title
  73. set realname = \"$realname\"
  74. set from = \"$fulladdr\"
  75. set sendmail = \"msmtp -a $title\"
  76. alias me $realname <$fulladdr>
  77. set folder = \"$maildir/$title\"
  78. set header_cache = $cachedir/$title/headers
  79. set message_cachedir = $cachedir/$title/bodies
  80. set mbox_type = Maildir
  81. bind index,pager gg noop
  82. bind index,pager g noop
  83. bind index,pager M noop
  84. bind index,pager C noop
  85. bind index gg first-entry
  86. macro index o \"<shell-escape>mbsync -V $title<enter>\" \"run mbsync to sync $title\"
  87. unmailboxes *
  88. "
  89. else
  90. mutt_profile="# vim: filetype=neomuttrc
  91. # muttrc file for account $title
  92. set realname = \"$realname\"
  93. set from = \"$fulladdr\"
  94. set sendmail = \"msmtp -a $title\"
  95. alias me $realname <$fulladdr>
  96. set folder = \"imaps://$login@$imap:$iport\"
  97. set imap_user = \"$login\"
  98. set header_cache = $cachedir/$title/headers
  99. set message_cachedir = $cachedir/$title/bodies
  100. set imap_pass = \"\`pass mutt-wizard-$title\`\"
  101. set mbox_type = Maildir
  102. set ssl_starttls = yes
  103. set ssl_force_tls = yes
  104. bind index,pager gg noop
  105. bind index,pager g noop
  106. bind index,pager M noop
  107. bind index,pager C noop
  108. bind index gg first-entry
  109. unmailboxes *
  110. "
  111. fi
  112. printf "DONE.\\n"
  113. }
  114. askinfo() { \
  115. printf "Insert the \033[31memail address\033[0m that you want to autoconfigure for mutt/mbsync\\n\tEmail: \033[36m"
  116. read -r fulladdr
  117. printf "\033[0m"
  118. while ! echo "$fulladdr" | grep -E "$emailre" >/dev/null; do
  119. printf "That is not a valid \033[31memail address\033[0m, please retype the desired email.\\n\\nEmail: \033[36m\t"
  120. read -r fulladdr
  121. printf "\033[0m"
  122. done
  123. domain="$(echo "$fulladdr" | sed "s/.*@//")"
  124. search_query=$domain
  125. case "$domain" in
  126. protonmail.com|protonmail.ch|pm.me)
  127. search_query='protonmail.com' ;;
  128. *)
  129. while : ; do
  130. printf "\nIs your email hosted with Protonmail? [yes/no] "
  131. read -r is_protonmail
  132. case $is_protonmail in
  133. [Yy][Ee][Ss]) search_query='protonmail.com' && break;;
  134. [Nn][Oo]) break;;
  135. *) printf 'Please answer Yes or No'
  136. esac; done;
  137. esac
  138. printf "\\nSearching for \033[32m%s\033[0m in \033[34m\`domains.csv\`\033[0m..." "$domain"
  139. serverinfo="$(grep "^$search_query" "$muttshare/domains.csv" 2>/dev/null)"
  140. if [ -z "$serverinfo" ]; then
  141. search_query=$(echo "$search_query" | sed "s/\.[^\.]*$/\.\\\*/")
  142. serverinfo="$(grep "^$search_query" "$muttshare/domains.csv" 2>/dev/null)"
  143. fi
  144. if [ -z "$serverinfo" ]; then
  145. printf "Your email domain is not in mutt-wizard's database yet.\\nmutt-wizard will still autoconfigure everything, but you will have to manually type in your service's IMAP and SMTP server information.\\nYou can usually quickly find this by internet searching for it.\\n"
  146. printf "Insert the IMAP server for your email provider (excluding the port number)\\n\033[36m\t"
  147. read -r imap
  148. printf "\033[0mWhat is your server's IMAP port number? (Usually something like 993)\\n\033[36m\t"
  149. read -r iport
  150. printf "\033[0mInsert the SMTP server for your email provider (excluding the port number)\\n\033[36m\t"
  151. read -r smtp
  152. printf "\033[0mWhat is your server's SMTP port number? (Usually 587 or 465)\\n\033[36m\t"
  153. read -r sport
  154. printf "\033[0m\\nGreat! If you want to be helpful, copy the line below and you can add it to the \`domains.csv\` file on Github.\\nThis will make things easier for others who use your email provider.\\n\\n%s,%s,%s,%s,%s\\n\\nAlthough be sure to test to see if these settings work first! ;-)\\n" "$domain" "$imap" "$iport" "$smtp" "$sport"
  155. else
  156. IFS=, read -r service imap iport smtp sport <<EOF
  157. $serverinfo
  158. EOF
  159. printf "\\n\033[3;33mCongrats!\033[0m Server info has automatically been found, so you won't have to look anything up!\\n\t\033[1mIMAP server\033[0m: %s\\n\t\033[1mIMAP port\033[0m: %s\\n\t\033[1mSMTP server\033[0m: %s\\n\t\033[1mSMTP port\033[0m: %s\\nThis data will be used by the wizard.\\n" "$imap" "$iport" "$smtp" "$sport"
  160. case "$service" in
  161. gmail.com) printf "\033[31mREMEMBER: Gmail users must enable \"less secure\" (third-party) applications first for the sync to work:\\nhttps://support.google.com/accounts/answer/6010255\\n\033[0m" ;;
  162. protonmail.ch|protonmail.com|pm.me) printf "\033[31mREMEMBER: Protonmail users must install and configure Protonmail Bridge first for the sync to work:\\nhttps://protonmail.com/bridge/\\n\033[0m" && ssltype="None" ;;
  163. esac
  164. [ "$sport" = 465 ] && starttlsoff="tls_starttls off"
  165. fi
  166. printf "Enter the \033[35mfull name\033[0m you want to be identified by on this account.\\n\tReal name: "
  167. read -r realname
  168. printf "Enter a short, \033[36mone-word identifier\033[0m for this email account that will distinguish them from any other accounts you add.\\n\tAccount name: "
  169. read -r title
  170. while ! echo "$title" | grep "$namere" >/dev/null || ls "$accdir"/[0-9]"-$title.muttrc" >/dev/null 2>&1; do
  171. printf "\033[31mTry again\033[0m. Pick a nickname that is one word only including lowercase letters and _ or - and that you have \033[1mnot\033[0m used before.\\n\tAccount name: \033[36m\t"
  172. read -r title
  173. printf "\033[0m"
  174. done
  175. printf "If your account has a special username different from your address, insert it now. Otherwise leave this prompt totally blank.\\n\033[34mMost accounts will not have a separate login, so you should probably leave this blank.\033[0m\\n\tLogin(?): \033[36m"
  176. read -r login
  177. printf "\033[0m"
  178. [ -z "$login" ] && login="$fulladdr"
  179. [ "$accounttype" = "offline" ] && printf "If you want to limit the number of messages kept offline to a number, enter that number below. If you do not want to limit your mail and would like \`mbsync\` to sync all mail, press enter without typing a number.\\n\t" && read -r maxmes
  180. echo "$maxmes" | grep "[1-9]" >/dev/null || maxmes="0"
  181. getpass
  182. getprofiles
  183. mkdir -p "$muttdir" "$accdir" "$cachedir/$title/bodies" "$HOME/.config/msmtp"
  184. getaccounts
  185. for x in $(seq 1 9); do echo "$accounts" | grep "$x" >/dev/null 2>&1 || { export idnum="$x"; break ;}; done
  186. [ ! -f "$msmtprc" ] && echo "$msmtp_header" > "$msmtprc"
  187. echo "$msmtp_profile" >> "$msmtprc"
  188. command -V apt-get >/dev/null 2>&1 && ln -s "$msmtprc" "$HOME/.msmtprc" 2>/dev/null
  189. case "$service" in
  190. protonmail.ch|protonmail.com|pm.me) protonfinger || return 1 ;;
  191. esac
  192. echo "$mutt_profile" > "$accdir/$idnum-$title.muttrc"
  193. echo "$mbsync_profile" >> "$mbsyncrc"
  194. notmuchauto
  195. [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc" && echo "muttrc created."
  196. ! grep "^source.*mutt-wizard.muttrc" "$muttrc" >/dev/null && echo "source $mwconfig # mw-autogenerated" >> "$muttrc"
  197. ! grep "^source.*.muttrc" "$muttrc" | grep -v "$mwconfig" >/dev/null && echo "source $accdir/$idnum-$title.muttrc # mw-autogenerated" >> "$muttrc"
  198. echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$title.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" # mw-autogenerated" >> "$muttrc"
  199. }
  200. protonfinger() { printf "Getting Protonmail bridge fingerprint...\\n"
  201. fingerprint="$(msmtp --serverinfo --host=127.0.0.1 --port=1025 --tls --tls-certcheck=off | grep SHA256: | sed 's/^.*: //')"
  202. sed -ibu "s/account $title/&\ntls_trust_file\ntls_fingerprint $fingerprint/" "$msmtprc" ; rm -f "$msmtprc"bu
  203. }
  204. getpass() { while : ; do pass rm -f "mutt-wizard-$title" >/dev/null 2>&1
  205. pass insert "mutt-wizard-$title" && break; done ;}
  206. formatShortcut() { \
  207. while read -r data; do { echo "macro index,pager g$1 \"<change-folder>$data<enter>\" \"go to $2\" # mw-autogenerated"
  208. echo "macro index,pager M$1 \";<save-message>$data<enter>\" \"move mail to $2\" # mw-autogenerated"
  209. echo "macro index,pager C$1 \";<copy-message>$data<enter>\" \"copy mail to $2\" # mw-autogenerated"; } >> "$accdir/$idnum-$title.muttrc"
  210. done ;}
  211. tryconnect() { mkdir -p "$maildir/$title"
  212. if mailboxes="$(mbsync -l "$title" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
  213. [ "$accounttype" = "online" ] && sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -f "$mbsyncrc"bu
  214. printf "\033[32mMailboxes detected.\033[0m\\n"
  215. echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$title/{}"
  216. return 0
  217. else
  218. printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
  219. return 1
  220. fi ;}
  221. finalize() { \
  222. boxes="$(find "$maildir/$title/" -mindepth 1 -type d | sed "s/\ /\\\ /g;s/^.*\//=/;/=\(cur\|new\|tmp\)$/d")"
  223. [ -z "$boxes" ] && printf "\033[31mNo local mailboxes have been detected for %s.\033[0m\\nThis means that mbsync has not been successfully run.\\nRun mbsync, and if it has an error, be sure to check your password and server settings manually if needbe.\\n" "$title" && return
  224. printf "Setting default mailboxes for your Inbox, Sent, Drafts and Trash in mutt...\\n"
  225. spoolfile=$(echo "$boxes" | grep -i -m 1 inbox | sed 's/=/+/g')
  226. record=$(echo "$boxes" | grep -i -m 1 sent | sed 's/=/+/g')
  227. postponed=$(echo "$boxes" | grep -i -m 1 draft | sed 's/=/+/g')
  228. trash=$(echo "$boxes" | grep -i -m 1 trash | sed 's/=/+/g')
  229. sed -ibu "/^mailboxes\|^set record\|^set postponed\|^set trash\|^set spoolfile/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  230. { echo "set spoolfile = \"$spoolfile\""; echo "set record = \"$record\""; echo "set postponed = \"$postponed\""; echo "set trash = \"$trash\""; } >> "$accdir/$idnum-$title.muttrc"
  231. echo "mailboxes $(echo "$boxes" | sed -e "s/^\|$/\"/g" | tr "\n" " ")" >> "$accdir/$idnum-$title.muttrc"
  232. printf "Setting up your keyboard shortcuts for jumping between mailboxes...\\n"
  233. sed -ibu "/# mw-autogenerated/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  234. echo "$boxes" | grep -i inbox | head -n 1 | formatShortcut i inbox
  235. echo "$boxes" | grep -i sent | head -n 1 | formatShortcut s sent
  236. echo "$boxes" | grep -i draft | head -n 1 | formatShortcut d drafts
  237. echo "$boxes" | grep -i trash | head -n 1 | formatShortcut t trash
  238. echo "$boxes" | grep -i spam | head -n 1 | formatShortcut S spam
  239. echo "$boxes" | grep -i junk | head -n 1 | formatShortcut j junk
  240. echo "$boxes" | grep -i archive | head -n 1 | formatShortcut a archive
  241. [ "$accounttype" = "offline" ] && printf "All done.\\n\033[33mYou should now be able to run \`\033[32mmbsync %s\033[33m\` to begin to download your mail.\033[0m\\n" "$title"
  242. command -V urlview >/dev/null 2>&1 && [ ! -f "$HOME/.urlview" ] && echo "COMMAND \$BROWSER" > "$HOME/.urlview"
  243. return 0
  244. }
  245. confirm() { printf "Do you want to %s? [yes/N]\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  246. printf "Are you really, really sure you want to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  247. return 0 ;}
  248. pick() { printf "Select an accounts to %s:\\n" "$1"
  249. list
  250. read -r input
  251. [ -z "$input" ] && return 1
  252. title="$(echo "$accounts" | grep "$input" | awk '{print $2}')"
  253. [ -z "$title" ] && printf "Invalid response." && return 1
  254. return 0 ;}
  255. delete() { sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -rf "$mbsyncrc"bu
  256. rm -rf "${cachedir:?}/${title:?}" "$accdir/"[1-9]"-$title.muttrc"
  257. sed -ibu "/[0-9]-$title.muttrc/d" "$muttrc" ; rm -f "$muttrc"bu
  258. sed -ibu "/account $title/,/^\(\s*$\|account\)/d" "$msmtprc"; rm -f "$msmtprc"bu
  259. }
  260. asktype() { while : ; do
  261. printf "Do you want to keep your mail for this account offline with mbsync? [yes/no]\\n\t"
  262. read -r offnot
  263. case "$offnot" in
  264. [Yy][Ee][Ss]) accounttype="offline" && break ;;
  265. [Nn][Oo]) accounttype="online" && break ;;
  266. *) echo "Write out either yes or no completely. Try again or press ctrl-c to quit." ;;
  267. esac; done ;}
  268. purge() { confirm "delete all account data" || exit
  269. rm -rf "$mbsyncrc" "$accdir" "$HOME/.config/msmtp" "$cachedir"
  270. echo "All configs and account settings have been purged."
  271. sed -ibu "/\# mw-autogenerated/d" "$muttrc" ; rm -f "$muttrc"bu
  272. }
  273. syncwrapper() { mbsync "${1:--a}" &
  274. ( kill -46 "$(pidof "${STATUSBAR:-dwmblocks}")" >/dev/null 2>&1 ) 2>/dev/null
  275. wait
  276. ( kill -46 "$(pidof "${STATUSBAR:-dwmblocks}")" >/dev/null 2>&1 ) 2>/dev/null
  277. notmuch new
  278. }
  279. notmuchauto() { \
  280. [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
  281. [ -f "$NOTMUCH_CONFIG" ] && return 0
  282. nmbasic="[database]
  283. path=$maildir
  284. [user]
  285. name=$realname
  286. primary_email=$fulladdr
  287. [new]
  288. tags=unread;inbox;
  289. ignore=.mbsyncstate;.uidvalidity
  290. [search]
  291. exclude_tags=deleted;spam;
  292. [maildir]
  293. synchronize_flags=true
  294. [crypto]
  295. gpg_path=$GPG"
  296. echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
  297. trap 'echo -e "\033[0m\n"; exit' INT ABRT
  298. case "$1" in
  299. ls) list ;;
  300. add) asktype && askinfo && tryconnect && finalize || delete ;;
  301. pass) pick "change the password of" && getpass ;;
  302. delete) pick delete && confirm "delete the \`$title\` profile" && delete ;;
  303. sync) syncwrapper $2 ;;
  304. purge) purge ;;
  305. *) cat << EOF
  306. mw: mutt-wizard, auto-configure email accounts for mutt
  307. including downloadable mail with \`isync\`.
  308. Allowed options:
  309. add Add and autoconfigure an email address (9 max.)
  310. ls List configured accounts
  311. delete Pick an account to delete
  312. purge Delete all accounts and settings
  313. sync Syncs mail and updates notmuch database
  314. all else Print this message
  315. NOTE: Once at least one account is added, you can run
  316. \`mbsync -a\` to begin downloading mail.
  317. EOF
  318. esac